package com.hai.dao;

import com.hai.entity.BsRequestRecord;
import com.hai.entity.BsRequestRecordExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsRequestRecordMapper extends BsRequestRecordMapperExt {
    @SelectProvider(type=BsRequestRecordSqlProvider.class, method="countByExample")
    long countByExample(BsRequestRecordExample example);

    @DeleteProvider(type=BsRequestRecordSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsRequestRecordExample example);

    @Delete({
        "delete from bs_request_record",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_request_record (source_id, source_type, ",
        "order_no, request_content, ",
        "return_content, operator_id, ",
        "operator_name, create_time, ",
        "update_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{sourceId,jdbcType=VARCHAR}, #{sourceType,jdbcType=INTEGER}, ",
        "#{orderNo,jdbcType=VARCHAR}, #{requestContent,jdbcType=VARCHAR}, ",
        "#{returnContent,jdbcType=VARCHAR}, #{operatorId,jdbcType=BIGINT}, ",
        "#{operatorName,jdbcType=VARCHAR}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsRequestRecord record);

    @InsertProvider(type=BsRequestRecordSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsRequestRecord record);

    @SelectProvider(type=BsRequestRecordSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="source_id", property="sourceId", jdbcType=JdbcType.VARCHAR),
        @Result(column="source_type", property="sourceType", jdbcType=JdbcType.INTEGER),
        @Result(column="order_no", property="orderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="request_content", property="requestContent", jdbcType=JdbcType.VARCHAR),
        @Result(column="return_content", property="returnContent", jdbcType=JdbcType.VARCHAR),
        @Result(column="operator_id", property="operatorId", jdbcType=JdbcType.BIGINT),
        @Result(column="operator_name", property="operatorName", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsRequestRecord> selectByExample(BsRequestRecordExample example);

    @Select({
        "select",
        "id, source_id, source_type, order_no, request_content, return_content, operator_id, ",
        "operator_name, create_time, update_time, ext_1, ext_2, ext_3",
        "from bs_request_record",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="source_id", property="sourceId", jdbcType=JdbcType.VARCHAR),
        @Result(column="source_type", property="sourceType", jdbcType=JdbcType.INTEGER),
        @Result(column="order_no", property="orderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="request_content", property="requestContent", jdbcType=JdbcType.VARCHAR),
        @Result(column="return_content", property="returnContent", jdbcType=JdbcType.VARCHAR),
        @Result(column="operator_id", property="operatorId", jdbcType=JdbcType.BIGINT),
        @Result(column="operator_name", property="operatorName", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsRequestRecord selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsRequestRecordSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsRequestRecord record, @Param("example") BsRequestRecordExample example);

    @UpdateProvider(type=BsRequestRecordSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsRequestRecord record, @Param("example") BsRequestRecordExample example);

    @UpdateProvider(type=BsRequestRecordSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsRequestRecord record);

    @Update({
        "update bs_request_record",
        "set source_id = #{sourceId,jdbcType=VARCHAR},",
          "source_type = #{sourceType,jdbcType=INTEGER},",
          "order_no = #{orderNo,jdbcType=VARCHAR},",
          "request_content = #{requestContent,jdbcType=VARCHAR},",
          "return_content = #{returnContent,jdbcType=VARCHAR},",
          "operator_id = #{operatorId,jdbcType=BIGINT},",
          "operator_name = #{operatorName,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsRequestRecord record);
}